// hide source info
dict_hide_source = true
dict_hide_thesaurus = false
// just show one type at one time
dict_phonetic_swtich = false
// only when dict_phonetic_swtich is enabled, it takes effect.
dict_phonetic_respelling = false
// use online audio (if enable, you can delete 1.mdd)
dict_online_pron = false
dict_mobile_compatable = true


dict_nav_class = "nav-dict"
is_dictionary_loaded = 'undefined' != typeof (is_dictionary_loaded)
console.log("is_dictionary_loaded", is_dictionary_loaded)
function get_dict_online_pron_url (src) {
    var parts = src.split('/');
    var dir = parts[parts.length - 2];
    var name = parts[parts.length - 1];
    return "https://static.sfdict.com/audio/" + dir + "/" + name;
}
!is_dictionary_loaded && document.addEventListener('DOMContentLoaded', function () {
    dict_hide_source && elementsHide(".Fh8wBkIPYAvfjFaJ1ozj")
    dict_hide_thesaurus && elementsHide("a[href*=thesaurus\\.com]")
    dictionary.addNav()

   dict_phonetic_swtich && elementsClick(".dict-ipa",function (ele) {
        hideEle(ele)
        elementsShow(".LgvbRZvyfgILDYMd8Lq6")
    })

   dict_phonetic_swtich && elementsClick(".LgvbRZvyfgILDYMd8Lq6",function (ele){
        if (document.querySelector(".dict-ipa")){
            hideEle(ele)
            elementsShow(".dict-ipa")
        }
    })
	dict_phonetic_swtich && elementsHide(dict_phonetic_respelling? ".dict-ipa" : ".LgvbRZvyfgILDYMd8Lq6");
    dict_online_pron && elementsFn( "a.dict-audio", function (element) {
        console.log(element);
        element.href = get_dict_online_pron_url(element.href);
        element.onclick = function (e) {
            e.preventDefault();
            new Audio(element.href).play();
        }
    });

    dict_mobile_compatable && dictionary.addViewportMeta()

})

if (typeof Element !== "undefined") {
    if (!Element.prototype.matches) {
        Element.prototype.matches = Element.prototype.msMatchesSelector || Element.prototype.webkitMatchesSelector;
    }

    if (!Element.prototype.closest) {
        Element.prototype.closest = function (s) {
            var el = this;

            do {
                if (el.matches(s)) return el;
                el = el.parentElement || el.parentNode;
            } while (el !== null && el.nodeType === 1);

            return null;
        };
    }
}
dictionary = {
    addNav: function () {
        var root = document.querySelector(".HjmF_6uYqSRDdE7yX2Wy  section")
        if (root.children.length < 2)
            return;
        let container = document.createElement('div');
        container.setAttribute("class", dict_nav_class);
        for (let i = 0; i < root.children.length; i++) {
            var ele = root.children[i]
            let sp = document.createElement('li');
            if(!ele.id) continue
            sp.textContent = ele.id;
            sp.setAttribute("show-id","#"+ele.id)
            if (i === 0) {
                sp.classList.add('active');
            }
            sp.addEventListener("click", function () {
                let showId = this.getAttribute("show-id")
                for (let j = 0; j < container.children.length; j++) {
                    let eee = container.children[j];
                    if (eee.getAttribute("show-id") === showId){
                        this.classList.add('active');
                        elementsShow(showId)
                    }else {
                        eee.classList.remove('active');
                        elementsHide(eee.getAttribute("show-id"))
                    }
                }
            })
            container.appendChild(sp);
        }
        let sp = document.createElement('li');
        sp.textContent = "All";
        container.appendChild(sp)
        sp.addEventListener("click", function () {
            for (let j = 0; j < container.children.length; j++) {
                container.children[j].classList.remove('active');
                elementsShow(container.children[j].getAttribute("show-id"))
            }
            this.classList.add('active');
        })
        root.insertBefore(container, root.childNodes[0]);
    },
    addViewportMeta: function () {
        const meta = document.createElement('meta');
        meta.content = 'width=device-width,initial-scale=1,minimum-scale=1,maximum-scale=1,user-scalable=no,viewport-fit=cover';
        meta.name = 'viewport';
        document.querySelector(".HjmF_6uYqSRDdE7yX2Wy").closest("html").querySelector("head").appendChild(meta);
    }

}

//  common js
function elementsFn(selector, fn) {
    var eles = document.querySelectorAll(selector);
    for (var i = 0; i < eles.length; i++) {
        fn(eles[i]);
    }
}

function elementsClick(selector, fn) {
    elementsFn(selector, function (ele) {
        ele.addEventListener("click", function (event) {
            fn(ele, event);
        })
    })
}

function elementsDisplay(selector, value) {
    elementsFn(selector, function (ele) {
        ele.style.display = value;
    })
}

function elementsHide(selector) {
    elementsDisplay(selector, "none")
}

function elementsShow(selector) {
    elementsDisplay(selector, "block")
}

function get_elements() {
    var selector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "input";
    var cond = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (el) {
        return el;
    };
    var eles = document.querySelectorAll(selector);
    var elements = [];
    for (var i = 0; i < eles.length; i++) {
        if (cond(eles[i])) {
            elements.push(eles[i]);
        }
    }
    return elements;
}

function hideEle(ele) {
    ele.style.display = 'none';
}

function showEle(ele) {
    ele.style.display = 'block';
}

function addScript(src, func) {
    let script = document.createElement('script');
    script.type = 'text/javascript';
    document.body.appendChild(script);
    if (src) {
        script.src = src;
    }
    script.onload = func;
}

function vConsole() {
    if ('undefined' == typeof (VConsole)) {
        addScript("https://cdn.bootcss.com/vConsole/3.15.0/vconsole.min.js", function () {
            var vConsole = new VConsole();
        })
    }
}